exception 异常捕获
博客专区 > Lee12 的博客 > 博客详情
exception 异常捕获
Lee12 发表于9个月前
exception 异常捕获
  • 发表于 9个月前
  • 阅读 2
  • 收藏 0
  • 点赞 0
  • 评论 0

移动开发云端新模式探索实践 >>>   

package exception;


import java.util.InputMismatchException;
import java.util.Scanner;

/**
 * 除法
 * 用户输入两个整数,计算商
 */
public class Devide {
    public static void main(String[]args){
        int a,b,c;//定义变量
        Scanner in=new Scanner(System.in);//实力话Scanner对象
       System.out.print("请输入两个整数:");//用户提示
        try {
            a=in.nextInt();//输入一个整数,存入变量a中
            b=in.nextInt();
            c=a/b;
            System.out.println("商为:"+c);
        } catch (InputMismatchException e) {
         //e.printStackTrace();//异常追踪 调试程序时显示追踪信息
            System.out.println("你只能输入数字!");
        }
        catch (ArithmeticException e){
           // e.printStackTrace();
            System.out.println("除数不能为0!");
        }
       // finally {
            System.out.println("程序结束!");//finally可以省略,在catch之后则就表示finally语句
       // }
    }
}
package exception;

import java.util.Scanner;

public class Devide1 {
    public static void main(String[]args){
        int a,b,c;//定义变量
        Scanner in=new Scanner(System.in);//实力话Scanner对象
        System.out.print("请输入两个数:");//用户提示
        try {
            a=in.nextInt();//输入一个整数,存入变量a中
            b=in.nextInt();
            try{
                c=a/b;
                System.out.println("商为:"+c);
        } catch (Exception e) {
            //e.printStackTrace();//异常追踪 调试程序时显示追踪信息
            System.out.println("除数不能为0!");
        }
        }
        catch (Exception e){
            // e.printStackTrace();
            System.out.println("你只能输入数字!");
        }
        System.out.println("程序结束!");//finally可以省略,在catch之后则就表示finally语句
    }
}
package exception;

import java.util.Scanner;

public class Devide2 {
    public static void main(String[]args){
        float a,b,c;//定义变量
        Scanner in=new Scanner(System.in);//实力话Scanner对象
        System.out.print("请输入两个数:");//用户提示
        try {
            a=in.nextFloat();//输入一个整数,存入变量a中
            b=in.nextFloat();
            try{
                c=a/b;
                if(String.valueOf(c).equals("Infinity")){
                    throw new ArithmeticException();//抛出异常
                }
                System.out.println("商为:"+c);
        } catch (Exception e) {
            System.out.println("除数不能为0!");
        }
        }
        catch (Exception e){
            System.out.println("你只能输入数字!");
        }
        System.out.println("程序结束!");//finally可以省略,在catch之后则就表示finally语句
    }
package exception;

public class Devide3 {
    private String name;
    private int age;
    public String getName(){
        return  name;
    }
    public void setName(String name){
        this.name=name;
    }
    public int getAge(){
        return  age;
    }
    //设置年龄
    public void setAge(int age)throws AgeException{
      if (age<0) throw new AgeException();
        this.age=age;
    }
    public static void main(String[]args){
        Devide3 s=new Devide3();
        try{
            s.setAge(-2);
        } catch (AgeException e) {
          // e.printStackTrace();
            System.out.println(e.getMessage());
        }
    }
}
自定义异常

package exception;

public class AgeException extends Exception {
    @Override
    public String getMessage() {
        return "年龄不能为负数";
    }
}
标签: Java
  • 打赏
  • 点赞
  • 收藏
  • 分享
共有 人打赏支持
粉丝 4
博文 12
码字总数 11258
×
Lee12
如果觉得我的文章对您有用,请随意打赏。您的支持将鼓励我继续创作!
* 金额(元)
¥1 ¥5 ¥10 ¥20 其他金额
打赏人
留言
* 支付类型
微信扫码支付
打赏金额:
已支付成功
打赏金额: